package com.sun.java.swing.plaf.windows;

import javax.swing.UIDefaults;
import java.awt.Color;
import javax.swing.UIManager;
import java.awt.Graphics;
import javax.swing.JSeparator;
import javax.swing.JToolBar;
import java.awt.Dimension;
import javax.swing.plaf.ComponentUI;
import javax.swing.JComponent;
import javax.swing.plaf.basic.BasicToolBarSeparatorUI;

public class WindowsToolBarSeparatorUI extends BasicToolBarSeparatorUI
{
    public WindowsToolBarSeparatorUI() {
    }
    
    public static ComponentUI createUI(JComponent component) {
        return new WindowsToolBarSeparatorUI();
    }
    
    @Override
    public Dimension getPreferredSize(JComponent component) {
        Dimension separatorSize = ((JToolBar.Separator)component).getSeparatorSize();
        Dimension size;
        if (separatorSize != null) {
            size = separatorSize.getSize();
        }
        else {
            size = new Dimension(6, 6);
            XPStyle xp = XPStyle.getXP();
            if (xp != null) {
                XPStyle.Skin skin = xp.getSkin(component, (((JSeparator)component).getOrientation() == 1) ? TMSchema.Part.TP_SEPARATOR : TMSchema.Part.TP_SEPARATORVERT);
                size.width = skin.getWidth();
                size.height = skin.getHeight();
            }
            if (((JSeparator)component).getOrientation() == 1) {
                size.height = 0;
            }
            else {
                size.width = 0;
            }
        }
        return size;
    }
    
    @Override
    public Dimension getMaximumSize(JComponent component) {
        Dimension preferredSize = this.getPreferredSize(component);
        if (((JSeparator)component).getOrientation() == 1) {
            return new Dimension(preferredSize.width, 32767);
        }
        return new Dimension(32767, preferredSize.height);
    }
    
    @Override
    public void paint(Graphics graphics, JComponent component) {
        int n = ((JSeparator)component).getOrientation() == 1;
        Dimension size = component.getSize();
        XPStyle xp = XPStyle.getXP();
        if (xp != null) {
            XPStyle.Skin skin = xp.getSkin(component, n ? TMSchema.Part.TP_SEPARATOR : TMSchema.Part.TP_SEPARATORVERT);
            skin.paintSkin(graphics, n ? ((size.width - skin.getWidth()) / 2) : 0, n ? 0 : ((size.height - skin.getHeight()) / 2), n ? skin.getWidth() : size.width, n ? size.height : skin.getHeight(), null);
        }
        else {
            Color color = graphics.getColor();
            UIDefaults lookAndFeelDefaults = UIManager.getLookAndFeelDefaults();
            Color color2 = lookAndFeelDefaults.getColor("ToolBar.shadow");
            Color color3 = lookAndFeelDefaults.getColor("ToolBar.highlight");
            if (!(n == 0)) {
                int n3 = size.width / 2 - 1;
                graphics.setColor(color2);
                graphics.drawLine(n3, 2, n3, size.height - 2);
                graphics.setColor(color3);
                graphics.drawLine(n3 + 1, 2, n3 + 1, size.height - 2);
            }
            else {
                int n2 = size.height / 2 - 1;
                graphics.setColor(color2);
                graphics.drawLine(2, n2, size.width - 2, n2);
                graphics.setColor(color3);
                graphics.drawLine(2, n2 + 1, size.width - 2, n2 + 1);
            }
            graphics.setColor(color);
        }
    }
}
